#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>

using namespace std;

const int N=1024+5;

int n,m,del;
bool not_active[N][N];
vector<int>id[N];
int sum[N*N];

inline void add(int a,int b)
{
    m++;
    sum[m]=a+b;
    id[a].push_back(m);
    id[b].push_back(m);
}

bool seen_node[N];
bool now_online[N];

inline int not_euler() /// return -1 if euler
{
    for(int i=1;i<=n;i++)
    {
        if(now_online[i] && id[i].size()%2==1)
        {
            return i;
        }
    }
    return -1;
}

inline void bring_online(int nod)
{
    now_online[nod]=1;
    seen_node[nod]=1;
    for(auto &it:id[nod])
    {
        int nou=sum[it]-nod;
        if(now_online[nou]==0)
        {
            bring_online(nou);
        }
    }
}

vector<int>lol[N];
vector<int>road;
bool deleted[N*N];

inline void dfs(int nod)
{
    while(!lol[nod].empty())
    {
        int i=lol[nod].back();
        lol[nod].pop_back();
        if(deleted[i]==0)
        {
            deleted[i]=1;
            dfs(sum[i]-nod);
        }
    }
    road.push_back(nod);
}

vector<vector<int>>print;

inline void slove(int start)
{
    for(int i=1;i<=m;i++)
    {
        deleted[i]=0;
    }
    for(int i=1;i<=n;i++)
    {
        lol[i]=id[i];
    }
    for(int i=1;i<=n;i++)
    {
        now_online[i]=0;
    }
    bring_online(start);
    /**for(int i=1;i<=n;i++)
    {
        if(now_online[i])
        {
            cout<<i<<"\n";
        }
    }
    cout<<"\n\n\n"; **/
    int nod=not_euler();
    for(int i=1;i<=n && nod==-1;i++)
    {
        if(now_online[i])
        {
            nod=i; /// if it is eulerian than it can start every pozition
        }
    }
    dfs(nod);
    ///reverse(road.begin(),road.end());
    print.push_back(road);
    print.back().push_back(-1);
    road.clear();
}

int main()
{
   // freopen("input","r",stdin);
   // freopen("output","w",stdout);
   cin>>n>>del;
    n++;
    for(int i=1;i<=del;i++)
    {
        int a,b;
        cin>>a>>b;
        a++;
        b++;
        not_active[a][b]=1;
        not_active[b][a]=1;
    }

for(int a=1;a<=n;a++)
    {
        for(int b=a;b<=n;b++)
        {
            if(not_active[a][b]) continue;
            add(a,b);
        }
    }
    for(int i=1;i<=n;i++)
    {
        if(seen_node[i]==0)
        {
            slove(i);
        }
    }
    cout<<print.size()<<"\n";
    for(auto &x:print)
    {
        for(auto &it:x)
        {
            if(it==-1)
            {
                cout<<it<<" ";
            }
            else
            {
                cout<<it-1<<" ";
            }
        }
        cout<<"\n";
    }
    return 0;
}
