//#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <stack>
#include <queue>

using namespace std;

#define ll long long
#define MIN(a , b) (((a) < (b)) ? (a) : (b))
#define MAX(a , b) (((a) < (b)) ? (b) : (a))

int const nmax = 1024;

vector<int> g[5 + nmax];
int grad[5 + nmax];
int mat[5 + nmax][5 + nmax];
int mat2[5 + nmax][5 + nmax];
int mat3[5 + nmax][5 + nmax];

int used[5 + nmax];

vector<int> st;

void eulercycle(int node){
  for(int h = 0 ;h < g[node].size() ; h++){
    int to = g[node][h];
    if(0 < mat2[node][to]){
      mat2[node][to]--;
      mat2[to][node]--;
      eulercycle(to);
    }
  }
  st.push_back(node);
}

vector<vector<int>> sol;

void part(){
  vector<int> sep;
  //cout << ":";


  for(int i = 0 ; i < st.size() - 1; i++){
    //cout << st[i] << "->" << st[i + 1] << " ";
    if(mat3[st[i]][st[i + 1]] != 0){
      sep.push_back(i);
      //cout << "|" << mat3[st[i]][st[i + 1]] << " ";

      mat3[st[i]][st[i + 1]]--;
      mat3[st[i + 1]][st[i]]--;

    }
  }
  //cout << '\n';

  vector<int> mysol;

  if(0 < sep.size()){
    for(int i = sep.back() + 1; i < st.size() ; i++)
      mysol.push_back(st[i]);
    for(int i = 1 ; i < sep[0] ;i++){
      mysol.push_back(st[i]);
    }
    sol.push_back(mysol);
    for(int i = 1 ; i < sep.size() ; i++){
      mysol.clear();
      for(int j = sep[i - 1] + 1 ; j <= sep[i] ; j++)
        mysol.push_back(st[j]);
      sol.push_back(mysol);
    }


  } else {
    for(int i = 0 ; i < st.size() ; i++)
      mysol.push_back(st[i]);
    sol.push_back(mysol);
  }
}

void solve(int node){
  vector<int> cand;
  queue<int> q;
  q.push(node);
  used[node] = 1;
  cand.push_back(node);

  while(0 < q.size()){
    node = q.front();
    q.pop();
    for(int h = 0 ; h < g[node].size() ; h++){
      int to = g[node][h];
      if(used[to] == 0){
        cand.push_back(to);
        used[to] = 1;
        q.push(to);
      }
    }
  }
  ///verified

  int last = 0;

  for(int i = 0 ; i < cand.size() ; i++){
    if(grad[cand[i]] % 2 == 1){
      if(last == 0)
        last = cand[i];
      else {
        g[cand[i]].push_back(last);
        g[last].push_back(cand[i]);
        mat2[cand[i]][last]++;
        mat2[last][cand[i]]++;

        mat3[last][cand[i]]++;
        mat3[cand[i]][last]++;

        last = 0;
      }
    }
  }
  ///verified

  eulercycle(node);

  part();

}

int main()
{
  int n , m;
  cin >> n >> m;
  for(int i = 1 ; i <= m ; i++){
    int x , y;
    cin >> x >> y;
    mat[x][y] = mat[y][x] = 1;
  }
  for(int i = 0 ; i <= n ; i++)
    for(int j = i + 1 ; j <= n ; j++)
      if(mat[i][j] == 0) {
        grad[i]++;
        grad[j]++;

        mat2[i][j]++;
        mat2[j][i]++;

        g[j].push_back(i);
        g[i].push_back(j);
      }

  ///verified

  int last = 0;

  for(int i = 1 ; i <= n ; i++){
    if(used[i] == 0){
      solve(i);
    }
  }







  //cout << "Solution\n";

  cout << sol.size() << '\n';
  for(int i = 0 ; i < sol.size() ; i++){
    for(int j = 0 ; j < sol[i].size() ; j++){
      cout << sol[i][j] << " ";
      if(mat[sol[i][j]][sol[i][j]] == 0){
        cout << sol[i][j] << " ";
        mat[sol[i][j]][sol[i][j]] = 1;
      }

    }

    cout << -1 << '\n';
  }
  return 0;
}
/*
5 6
1 2
2 3
3 1
2 4
4 5
5 2

*/
