#include "namuhs.h"
#include <iostream>
using namespace std;

const int MAX_TREE = 262144, MAX_N = 100000;

unsigned char sign[MAX_N];

int nss;

struct Node {
    int cleft, cright, pmax, smax;
} tree[MAX_TREE];

void build(int i, int left, int right) {
    //cout << "BUILD FOR" << i << " " << left << " " << right << "\n";
    if (left == right - 1) {
        //cout << left << "<" << nss << "\n";
        if (left < nss && sign[left])
            tree[i].cleft = left, tree[i].cright = right, tree[i].pmax = right, tree[i].smax = left - 1;
        else
            tree[i].cleft = left, tree[i].cright = left, tree[i].pmax = left, tree[i].smax = left;
        return;
    }
    int mid = (left + right) / 2;
    int lc = 2 * i + 1, rc = 2 * i + 2;
    build(lc, left, mid);
    build(rc, mid, right);
    tree[i].pmax = tree[lc].pmax;
    if (compare_segments(left + 1, tree[rc].pmax, left + 1, tree[i].pmax))
        tree[i].pmax = tree[rc].pmax;
    tree[i].smax = tree[rc].smax;
    if (compare_segments(tree[lc].smax + 2, right, tree[i].smax + 2, right))
        tree[i].smax = tree[lc].smax;
    int bestX = left, bestY = tree[i].pmax - 1;
    int checkX, checkY;
    checkX = tree[i].smax + 1, checkY = right - 1;
    if (compare_segments(checkX + 1, checkY + 1, bestX + 1, bestY + 1))
        bestX = checkX, bestY = checkY;
    checkX = tree[lc].cleft, checkY = tree[lc].cright - 1;
    if (compare_segments(checkX + 1, checkY + 1, bestX + 1, bestY + 1))
        bestX = checkX, bestY = checkY;
    checkX = tree[rc].cleft, checkY = tree[rc].cright - 1;
    if (compare_segments(checkX + 1, checkY + 1, bestX + 1, bestY + 1))
        bestX = checkX, bestY = checkY;
    checkX = tree[lc].smax + 1, checkY = tree[rc].pmax - 1;
    if (compare_segments(checkX + 1, checkY + 1, bestX + 1, bestY + 1))
        bestX = checkX, bestY = checkY;
    tree[i].cleft = bestX;
    tree[i].cright = bestY + 1;
}

void find_max(int n, int& left, int& right) {
    nss = n;
    if (compare_segments(2, 2, 1, 2))
        sign[0] = 0;
    else
        sign[0] = 1;
    for (int i = 1; i < n; ++i)
        if (compare_segments(i, i, i, i + 1))
            sign[i] = 0;
        else
            sign[i] = 1;
    build(0, 0, n);
    //for (int i = 0; i <= 16; ++i)
    //    cout << i << ": " << tree[i].cleft << "-" << tree[i].cright << " " << " " << tree[i].pmax << " " << tree[i].smax << "\n";
    left = tree[0].cleft + 1;
    right = tree[0].cright;
}
