#pragma GCC optimize("O3")
#pragma GCC target("tune=native")

#include <bits/stdc++.h>
using namespace std;

typedef long double float80;

void solve();

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    auto start = chrono::high_resolution_clock::now();
#endif // DEBUG
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i)
        solve();
#ifdef DEBUG
    auto finish = chrono::high_resolution_clock::now();
    chrono::duration<double> d = finish - start;
    cerr << setprecision(9) << fixed << "Time: " << d.count() << "s\n";
#endif // DEBUG
    return 0;
}

const int MAX_N = 100000;

vector<int> edges[MAX_N];
int dp1[MAX_N], dp2[MAX_N], depths[MAX_N], v1[MAX_N];

int a, b, dist;

void updateDist(int newa, int newb, int newdist) {
    if (newdist > dist)
        a = newa, b = newb, dist = newdist;
}

void dfs1(int v, int p = -1) {
    for (int u : edges[v])
        if (u != p)
            dfs1(u, v);
    dp1[v] = 0;
    v1[v] = v;
    for (int u : edges[v])
        if (u != p && dp1[u] + 1 > dp1[v])
            dp1[v] = dp1[u] + 1, v1[v] = v1[u];
    int second_max = 0, second_v = v;
    for (int u : edges[v])
        if (u != p && v1[u] != v1[v] && second_max < dp1[u] + 1)
            second_max = dp1[u] + 1, second_v = v1[u];
    updateDist(second_v, v1[v], second_max + dp1[v]);
}

void dfs2(int v, int p = -1) {
    for (int u : edges[v])
        if (u != p)
            dfs2(u, v);
    depths[v] = 0;
    for (int u : edges[v])
        if (u != p)
            depths[v] = max(depths[v], depths[u] + 1);
    if (edges[v].size() == 1 && p != -1) {
        dp2[v] = 1;
    } else if (edges[v].size() == 2 || p == -1) {
        if (edges[v][0] != p)
            dp2[v] = max(dp2[edges[v][0]], 2);
        else
            dp2[v] = max(dp2[edges[v][0]], 2);
    } else {
        int depthestdepth = -1;
        int depthest = 0;
        for (int u : edges[v])
            if (u != p && depthestdepth < depths[u])
                depthestdepth = depths[u], depthest = u;
        //cout << "For " << v << " " << p << " " << depthest << "\n";
        int lddepth = -1;
        for (int u : edges[v])
            if (u != p && u != depthest && lddepth < depths[u])
                lddepth = depths[u];
        dp2[v] = max(max(dp2[depthest], lddepth + 2), 2);
    }
}

void solve() {
    int n, tmp1, tmp2;
    cin >> n;
    for (int i = 0; i < n; ++i)
        edges[i].clear();
    dist = -1;
    for (int i = 1; i < n; ++i) {
        cin >> tmp1 >> tmp2;
        edges[tmp1].push_back(tmp2);
        edges[tmp2].push_back(tmp1);
    }
    if (n < 2) {
        cout << n << "\n";
        return;
    }
    dfs1(0);
    //cout << a << "\n";
    dfs2(a);
    //for (int i = 0; i < n; ++i)
    //    cout << i << ": " << dp2[i] << " " << depths[i] << "\n";
    cout << dp2[a] << "\n";
}
