#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,avx,mmx,popcnt,tune=native")
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
#define long ll
#define double ld


const int ML = 200E6;
char * allocated;
char * pointer;

void * operator new(size_t n)
{
    void * res = (void *)pointer;
    pointer += n;
    return res;
}

void operator delete(void *) noexcept {}
void operator delete(void *, size_t) noexcept {}


void initialize()
{
    allocated = (char *)malloc(ML);
    pointer = allocated;
}


const int N = 1E5 + 10;

vector<int> g[N];

int solve(int v, int p)
{
    int answer = 2;

    if (g[v].size() == 1 && p >= 0)
    {
        answer = 1;
    }

    int max1 = -1E9, max2 = -1E9;
    for (int u : g[v])
    {
        if (u != p)
        {
            max2 = max(max2, solve(u, v));
            if (max2 > max1)
            {
                swap(max2, max1);
            }
        }
    }
    answer = max(answer, max1);
    answer = max(answer, max2 + 1);
    return answer;
}

int solve()
{
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
    {
        g[i].clear();
    }
    for (int a, b, i = 0; i < n - 1; ++i)
    {
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    int min_answer = 1E9;

    if (n == 1)
    {
        return 1;
    }

    vector<pair<int, int>> roots;

    for (int i = 0; i < n; ++i)
    {
        roots.emplace_back(g[i].size(), i);
    }

    sort(roots.begin(), roots.end());

    int cnt = 0;
    int bound = 1200000 / n + 1;

    for (auto root : roots)
    {
        if (min_answer <= 2 || cnt > bound)
        {
            break;
        }
        ++cnt;
        min_answer = min(min_answer, solve(root.second, -1));
    }
    if (min_answer == 3)
    {
        return 2;
    }
    return min_answer;
}

int main()
{
    initialize();
#ifdef LOCAL_PC
    freopen("input.txt", "r", stdin);
#endif // LOCAL_PC

    ios::sync_with_stdio(0);
    cin.tie(nullptr);


    int t;
    cin >> t;
    while (t--)
    {
        cout << solve() << '\n';
    }

    return 0;
}

