#include <iostream>
#include <vector>
//#define DEGUG_LOGS
using namespace std;

const int MAXN = 1025;

int n, k;
vector < pair < int, bool > > ln [MAXN];
bool used [MAXN][MAXN];
vector < int > ans_seq;

void clear ()
{
    for (int i = 0 ; i < MAXN ; i ++)
        for (int j = 0 ; j < MAXN ; j ++)
            used [i][j] = false;
    ans_seq.clear ();
}

void spaces (int used_dominos)
{
    for (int i = 0 ; i < used_dominos ; i ++)
        cout << " ";
}

int construct (int current, bool type, int inverts_left, int used_dominos = 0, int space = 0)
{
    //if (ans_seq.size () >= 2 and ans_seq [0] == ans_seq [1] and ans_seq [1] == 2)

    if (inverts_left < 0) return -1;

    #if defined(DEBUG_LOGS)
    spaces (space);
    cout << "current_side: " << current << " inverts left:" << inverts_left << " used_dominos: "<< used_dominos << endl;
    spaces (space);
    for (auto& x : ans_seq)
    {
        cout << x << " ";
    }
    cout << endl;
    #endif // DEBUG_LOGS

    if (used_dominos == (n + 2) * (n + 1) / 2 - k)
        return 0;
    if (used_dominos > (n + 2) * (n + 1) / 2 - k)
        return -1;
    if (current != -1)
    {
        #if defined(DEBUG_LOGS)
        spaces (space);
        cout << "ln [" << current << "].size () = " << ln [current].size () << endl;
        #endif // DEBUG_LOGS
        for (auto& dominos : ln [current])
        {
            #if defined(DEBUG_LOGS)
            spaces (space);
            cout << "ln [" << current << "][] = (" << dominos.first << " " << dominos.second << ")" << endl;
            #endif // DEBUG_LOGS
            if (not used [current][dominos.first] and dominos.second == type)
            {
                #if defined(DEBUG_LOGS)
                spaces (space);
                cout << "try out: (" << current << ", " << dominos.first << ") + " << dominos.second << endl;
                #endif // DEBUG_LOGS
                ans_seq.push_back(dominos.first);
                used [current][dominos.first] = used [dominos.first][current] = true;
                int ans;
                if ((ans = construct (dominos.first, type, inverts_left, used_dominos + 1, space + 1)) != -1)
                {
                    #if defined(DEBUG_LOGS)
                    spaces (space);
                    cout << "returning " << ans << endl;
                    #endif // DEBUG_LOGS
                    return ans;
                }
                used [current][dominos.first] = used [dominos.first][current] = false;
                ans_seq.pop_back();

                #if defined(DEBUG_LOGS)
                spaces (used_dominos);
                cout << "tried out: (" << current << ", " << dominos.first << ") + " << dominos.second << endl;
                #endif // DEBUG_LOGS
            }
        }
        ans_seq.push_back(-1);
        int ans;
        if ((ans = construct (-1, type, inverts_left - 1, used_dominos, space + 1)) != -1)
        {
            #if defined(DEBUG_LOGS)
            spaces (space);
            cout << "returning " << ans << endl;
            #endif // DEBUG_LOGS
            return ans + 1;
        }
        ans_seq.pop_back();
        return -1;
    }
    else
    {
        for (int blah = 0 ; blah <= n ; blah ++)
        {
            #if defined(DEBUG_LOGS)
            spaces (space);
            cout << "STARTING POINTS: " << blah << endl;
            #endif // DEBUG_LOGS
            for (auto& dominos : ln [blah])
            {
                if (used_dominos == 0) clear ();

                #if defined(DEBUG_LOGS)
                spaces (space);
                cout << "try first: (" <<blah << " " << dominos.first << ") " << dominos.second << " =?= " << type <<endl;
                #endif // DEBUG_LOGS
                if (not used [blah][dominos.first] and dominos.second == type)
                {
                    ans_seq.push_back(blah);
                    ans_seq.push_back(dominos.first);
                    used [blah][dominos.first] = used [dominos.first][blah] = true;
                    int ans;
                    if ((ans = construct (dominos.first, dominos.second, inverts_left, used_dominos + 1, space + 1)) != -1)
                    {
                        return ans;
                    }
                    used [blah][dominos.first] = used [dominos.first][blah] = false;
                    ans_seq.pop_back();
                    ans_seq.pop_back();
                }
            }
        }
    }
    return -1;
}

int main ()
{
    cin.tie (nullptr);
    ios::sync_with_stdio (false);

    cin >> n;
    for (int i = 0 ; i <= n ; i ++)
    {
        ln [i].resize (n + 1);
    }
    for (int i = 0 ; i <= n ; i ++)
    {
        for (int j = i ; j <= n ; j ++)
        {
            //ln [j][i] = {i, 0};
            ln [i][j] = {j, 0};
        }
    }
    cin >> k;
    for (int i = 0 ; i < k ; i ++)
    {
        int a, b;
        cin >> a >> b;
        ln [a][b] = {b, 1};
        ln [b][a] = {a, 1};
    }

    if (k == 0)
    {
        while (true){}
        cout << "0\n-1\n";
        return 0;
    }

    int inverts_min = -1, inverts_max = (n + 2) * (n + 1) / 2;

    //cout << "---------------------\n";
    //cout << inverts_min << " " << inverts_max << endl;
    while (inverts_max - inverts_min > 1)
    {
        int mid = (inverts_max + inverts_min) / 2;
        //cout << "---------------------\nmid = " << mid << endl;
        int res = construct(-1, 0, mid);
        //cout << "response: " << res << endl;
        if (res != -1)
            inverts_max = res;
        else
            inverts_min = mid;
        //cout << inverts_min << " " << inverts_max << endl;
        //cout << "---------------------\n";
    }
    //cout << "---------------------\n";
    cout << inverts_max + 1<< endl;
//    clear ();
//    construct(-1, 0, inverts_max);
    //int ans = 0;
    //for (auto& x : ans_seq)
    //    ans += (x == -1);
    //cout << ans + 1 << endl;
    for (auto& x : ans_seq)
    {
        if (x != -1)
            cout << x << " ";
        else
            cout << x << "\n";
    }
    cout << -1;
}

/*
3 5
0 2
1 1
1 2
1 3
3 3
*/
